package com.loafle.overflow.central.module.discovery.service;



import com.loafle.overflow.central.commons.model.SessionMetadata;
import com.loafle.overflow.central.commons.service.MessagePublisher;
import com.loafle.overflow.central.module.discovery.model.DiscoveryStartInfo;
import com.loafle.overflow.core.annotation.ProbeAPI;
import com.loafle.overflow.core.annotation.WebappAPI;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.discovery.*;

import com.loafle.overflow.service.central.discovery.DiscoveryService;
import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.Date;

/**
 * Created by snoop on 17. 9. 28.
 */
@Service("DiscoveryService")
public class CentralDiscoveryService implements DiscoveryService {

    @Autowired
    private MessagePublisher messagePublisher;

    public void startDiscovery(DiscoveryStartInfo startInfo) throws OverflowException,IOException {

        ObjectMapper objectMapper = new ObjectMapper();

        String json = objectMapper.writeValueAsString(startInfo);

        System.out.println("Start Discovery");
        System.out.println(json);
//        this.messagePublisher.publishToProbe("/auth", noAuthProbe.getTempProbeKey(), "NoAuthProbeService.acceptNoAuthProbe", probe.getProbeKey());
    }

//     public boolean testDiscovery(int types, String obj) {

//         Domain domain = new Domain();
//         domain.setId(1);

// //        int typeInt = Integer.valueOf(types);
//         switch (types) {
//             case 1 :
//                 messagePublisher.publishToDomainMembers(domain, "DiscoveryService.discoveryIngHost", obj);
//                 break;
//             case 2 :
//                 messagePublisher.publishToDomain("/webapp", domain, "DiscoveryService.discoveryIngPort", obj);
//                 break;
//             case 3 :
//                 messagePublisher.publishToDomain("/webapp", domain, "DiscoveryService.discoveryIngService", obj);
//                 break;
//         }


//         return true;
// 		}
		
		@WebappAPI
		public void discoverZone(String probeID, DiscoverZone discoveryZone) {
			String requesterSessionID = SessionMetadata.getSessionID();
	
			messagePublisher.publishToProbe(probeID, "DiscoveryService.DiscoverZone", requesterSessionID, discoveryZone);
		}

		@WebappAPI
		public void discoverHost(String probeID, Zone zone, DiscoverHost discoveryHost) {
			String requesterSessionID = SessionMetadata.getSessionID();
	
			messagePublisher.publishToProbe(probeID, "DiscoveryService.DiscoverHost", requesterSessionID, zone, discoveryHost);
		}
	
		@WebappAPI
		public void discoverPort(String probeID, Host host, DiscoverPort discoveryPort) {
			String requesterSessionID = SessionMetadata.getSessionID();
	
			messagePublisher.publishToProbe(probeID, "DiscoveryService.DiscoverPort", requesterSessionID, host, discoveryPort);
		}

		@WebappAPI
		public void discoverService(String probeID, Port port, com.loafle.overflow.model.discovery.DiscoverService discoveryService) {
			String requesterSessionID = SessionMetadata.getSessionID();
	
			messagePublisher.publishToProbe(probeID, "DiscoveryService.DiscoverService", requesterSessionID, port, discoveryService);
		}

		@ProbeAPI
		public void discoverStart(String requesterSessionID, Date startDate) {
			messagePublisher.publishToMemberSession(requesterSessionID, "DiscoveryService.discoveryStart", startDate);			
		}
	
		@ProbeAPI
		public void discoverStop(String requesterSessionID, Date stopDate) {
			messagePublisher.publishToMemberSession(requesterSessionID, "DiscoveryService.discoveryStop", stopDate);			
		}
	
		@ProbeAPI
		public void discoveredZone(String requesterSessionID, Zone zone) {
			messagePublisher.publishToMemberSession(requesterSessionID, "DiscoveryService.discoveredZone", zone);			
		}
	
		@ProbeAPI
		public void discoveredHost(String requesterSessionID, Host host) {
			messagePublisher.publishToMemberSession(requesterSessionID, "DiscoveryService.discoveredHost", host);			
		}
	
		@ProbeAPI
		public void discoveredPort(String requesterSessionID, Port port) {
			messagePublisher.publishToMemberSession(requesterSessionID, "DiscoveryService.discoveredPort", port);			
		}

		@ProbeAPI
		public void discoveredService(String requesterSessionID, com.loafle.overflow.model.discovery.Service service) {
			messagePublisher.publishToMemberSession(requesterSessionID, "DiscoveryService.discoveredService", service);			
		}
	
}