package com.loafle.overflow.central.module.generator.service;

import com.loafle.overflow.crawler.config.*;
import com.loafle.overflow.central.module.meta.model.MetaSensorItemKey;
import com.loafle.overflow.central.module.sensor.model.Sensor;
import com.loafle.overflow.central.module.sensor.model.SensorItem;
import org.codehaus.jackson.map.ObjectMapper;
import org.codehaus.jackson.type.TypeReference;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by snoop on 17. 9. 6.
 */
@Service("InfraHostWMIGenerator")
public class InfraHostWMIGenerator {

    @Autowired
    private GenerateUtil generateUtil;

    public void process(List<SensorItem> sensorItems, Map<Integer, MetaSensorItemKey> keyMap, Sensor dbSensor, Config config) throws IOException {

        Map<String, List<MetaSensorItemKey>> metricMap = null;
        metricMap = this.generateUtil.sortItems(sensorItems, keyMap);

//        MetaSensorItemKey itemKey = null;
//
//        for(SensorItem sItem : sensorItems) {
//            itemKey = keyMap.get(sItem.getItem().getId());
//            if(metricMap.containsKey(itemKey.getFroms()) == false) {
//                metricMap.put(itemKey.getFroms(), new ArrayList<>());
//            }
//            metricMap.get(itemKey.getFroms()).add(itemKey);
//        }

        List<Item> itemList = new ArrayList<>();
        Item item = null;
        QueryInfo queryInfo = null;
        MappingInfo mappingInfo = null;

        StringBuffer stringBuffer = new StringBuffer();

        Map<String, Object> extendMap = new HashMap<>();
        extendMap.put("nameSpace", "root/cimv2");
        extendMap.put("wmicPath", "/home/snoop/temp/wmic");


        List<Keys> keysList = null;
        MetaSensorItemKey tempItemKey = null;
        Keys keys = null;
        for(Map.Entry<String, List<MetaSensorItemKey>> elems : metricMap.entrySet()) {
            keysList =  new ArrayList<>();
            item = new Item();
            stringBuffer.setLength(0);

            stringBuffer.append("SELECT ");

            for(int indexI = 0; indexI < elems.getValue().size(); ++indexI) {

                tempItemKey = elems.getValue().get(indexI);
                stringBuffer.append(tempItemKey.getKey());
                if(indexI + 1 < elems.getValue().size()) {
                    stringBuffer.append(", ");
                }

//                keys = new Keys();
//                keys.setKey(tempItemKey.getKey());
//                keys.setMetric(tempItemKey.getItem().getKey());
                keysList.add(this.generateUtil.createKeys(tempItemKey));
            }


            List<String> arrayColumns = null;

            String json = tempItemKey.getOption();
            if(json != null && json.length() > 0) {
                HashMap<String,Object> optionMap;
                optionMap = new ObjectMapper().readValue(json, new TypeReference<HashMap<String,Object>>() {});

                Object obj = null;
                obj = optionMap.get("appends");
                if(obj != null) {
                    List<String> appendsList = (List<String>)obj;
                    for(String append : appendsList) {
                        stringBuffer.append(", ");
                        stringBuffer.append(append);
                    }
                }

                stringBuffer.append(" FROM ");
                stringBuffer.append(elems.getKey());

                obj = optionMap.get("where");
                if(obj != null) {
                    String where = (String)obj;
                    stringBuffer.append(" WHERE ");
                    stringBuffer.append(where);
                }

                obj = optionMap.get("arrayColumns");
                if(obj != null) {
                    arrayColumns = (List<String>)obj;
                }

            }
            else {
                stringBuffer.append(" FROM ");
                stringBuffer.append(elems.getKey());
            }

            queryInfo = new QueryInfo();
            queryInfo.setQuery(stringBuffer.toString());
            queryInfo.setExtend(extendMap);

            mappingInfo = new MappingInfo();
            mappingInfo.setParseDirection("col");
            mappingInfo.setArrayColumns(arrayColumns);

            item.setMappingInfo(mappingInfo);
            item.setQueryInfo(queryInfo);
            item.setKeys(keysList);

            itemList.add(item);

        }

        config.setItems(itemList);

    }
}
