package com.loafle.overflow.central.module.history.service;

import com.loafle.overflow.central.commons.utils.PageUtil;
import com.loafle.overflow.central.module.history.dao.HistoryDAO;
import com.loafle.overflow.core.model.PageParams;
import com.loafle.overflow.model.domain.Domain;
import com.loafle.overflow.model.history.History;
import com.loafle.overflow.model.meta.MetaHistoryType;
import com.loafle.overflow.model.probe.Probe;
import com.loafle.overflow.service.central.history.HistoryService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Service;

@Service("HistoryService")
public class CentralHistoryService implements HistoryService {
    @Autowired
    private HistoryDAO historyDAO;

    public History regist(History history) {
        return this.historyDAO.save(history);
    }


    public Page<History> readAllByProbeAndType(Probe probe, MetaHistoryType type, PageParams pageParams) {
        return this.historyDAO.findAllByProbeAndType(probe, type, PageUtil.getPageRequest(pageParams));
    }

    public Page<History> readAllByProbe(Probe probe, com.loafle.overflow.core.model.PageParams pageParams) {
        return this.historyDAO.findAllByProbe(probe, PageUtil.getPageRequest(pageParams));
    }

    public Page<History> readAllByDomain(Domain domain, PageParams pageParams) {
        return this.historyDAO.findAllByDomain(domain, PageUtil.getPageRequest(pageParams));
    }

    public Page<History> readAllByDomainAndType(Domain domain, MetaHistoryType type, PageParams pageParams) {
        return this.historyDAO.findAllByDomainAndType(domain, type, PageUtil.getPageRequest(pageParams));
    }

}
