package com.loafle.overflow.central.module.sensor.service;

import com.loafle.overflow.central.module.meta.model.MetaSensorDisplayItem;
import com.loafle.overflow.central.module.meta.model.MetaSensorItemKey;
import com.loafle.overflow.central.module.sensor.dao.SensorItemDependencyDAO;
import com.loafle.overflow.model.sensor.SensorItemDependency;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by insanity on 17. 9. 20.
 */

@Service("SensorItemDependencyService")
public class CentralSensorItemDependencyService {

    @Autowired
    private SensorItemDependencyDAO sensorItemDependencyDAO;

    public SensorItemDependency regist(SensorItemDependency dependency) {
        return this.sensorItemDependencyDAO.save(dependency);
    }

    public List<MetaSensorItemKey> readAllByDisplayItem(MetaSensorDisplayItem displayItem) {
        return this.sensorItemDependencyDAO.findAllByDisplayItem(displayItem);
    }

    public Map<String, List<MetaSensorItemKey>> readAllByDisplayItems(List<MetaSensorDisplayItem> displayItems) {

        Map<String, List<MetaSensorItemKey>> map = new HashMap<String, List<MetaSensorItemKey>>();

        for (MetaSensorDisplayItem displayItem : displayItems) {
            List<MetaSensorItemKey> itemKeys = this.sensorItemDependencyDAO.findAllByDisplayItem(displayItem);
            map.put(displayItem.getKey(), itemKeys);
        }

        return map;
    }
}
